package com.klipwallet.app2app.internal;

import org.json.JSONException;
import org.json.JSONObject;

import com.klipwallet.app2app.api.KlipProtocol;
import com.klipwallet.app2app.api.request.model.BAppInfo;
import com.klipwallet.app2app.api.request.KlipRequest;

public class PrepareRequest {
    private BAppInfo bapp; // required
    private KlipRequest klipRequest;
    private String type; // required

    public void setBapp(BAppInfo bapp) {
        this.bapp = bapp;
    }

    public void setKlipRequest(KlipRequest klipRequest) {
        this.klipRequest = klipRequest;
    }

    public void setType(String type) {
        this.type = type;
    }

    public BAppInfo getBapp() {
        return bapp;
    }

    public KlipRequest getKlipRequest() {
        return klipRequest;
    }

    public String getType() {
        return type;
    }

    public JSONObject toJson() {
        JSONObject obj = new JSONObject();
        try {
            obj.put(KlipProtocol.TYPE, type);
            obj.put(KlipProtocol.BAPP, bapp.toJson());

            if(klipRequest != null) {
                if(type == KlipProtocol.SIGN_MESSAGE) { // send klay, send token, send card, execute contract
                    obj.put(KlipProtocol.MESSAGE, klipRequest.toJson());
                } else { // sign message
                    obj.put(KlipProtocol.TRANSACTION, klipRequest.toJson());
                }
            }

            return obj;
        } catch (JSONException e) {
            throw new IllegalArgumentException("JSON parsing error. Malformed parameters were provided. detailed error message: " + e.toString());
        }
    }
}
